datablock AudioProfile(ShotgunShootSound)
{
   filename    = "./shoot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ShotgunPump1s)
{
   filename    = "./pump1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ShotgunPump2s)
{
   filename    = "./pump2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ShotgunMagout)
{
   filename    = "./magout.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ShotgunMagin)
{
   filename    = "./magin.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("Shotgun",   '%1 turned himself into swiss cheese.',    '%2 shot some buckshot into %1.',0.2,1);
datablock ItemData(ShotgunItem : utaItem)
{
	shapeFile = "./item.dts";
	uiName = "Shotgun";
	iconName = "./icon_ui";
	image = ShotgunImage;
	maxAmmo = 6;
};
datablock ShapeBaseImageData(ShotgunImage : utaImage)
{
   className = "WeaponImage";
   shapeFile = "./gun.dts";
   armReady = true;
   item = ShotgunItem;
   ammo = " ";
   projectile = utaProjectile;
   projectileType = Projectile;

   eyeOffset = "0.3 1.1 -0.4";

   casing = utaShellDebris;
   shellExitDir        = "1 1.3 -1.5";
   shellExitVariance   = 5.0;	
   shellVelocity       = 7.0;

   raycastWeaponRange = 80;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = utaProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 5; //Varies based on range
   raycastDirectDamageType = $DamageType::Shotgun;
   raycastSpreadCount = 18;
   raycastSpreadAmt = 0.005;
   raycastTracerProjectile = "";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 40;
   raycastVerticalImpulse = 10;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.95;
	stateSequence[0] = "equip";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateEmitter[2]					= utaFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= ShotgunShootSound;

		//FIRE
		
		stateName[3]			= "Delay";
		stateTransitionOnTimeout[3]     = "Delay2";
		stateTimeoutValue[3]            = 0.4;
		
		stateName[14]			= "Delay2";
		stateTransitionOnTimeout[14]     = "Delay3";
		stateTimeoutValue[14]            = 0.13;
		stateSound[14] = ShotgunPump1s;
		stateEjectShell[14]       	  = true;
		
		stateName[13]="Delay3";
		stateTransitionOnTimeout[13]     = "FireLoadCheckA";
		stateTimeoutValue[13]            = 0.42;
		stateSound[13] = ShotgunPump2s;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";
	
		//RELOAD
	
		stateName[6]				= "Reload";
		stateTimeoutValue[6]			= 0.00;
		stateSequence[6]                = "Reload";
		stateScript[6]				= "onReloadStart";
		stateTransitionOnTimeout[6]		= "Reload2";
		stateWaitForTimeout[6]			= true;
		
		stateName[16]="Reload2";
		stateTimeoutValue[16]=0.13;
		stateTransitionOnTimeout[16]="Reload3";
		
		stateName[17]="Reload3";
		stateTimeoutValue[17]=0.8;
		stateSound[17]=ShotgunMagout;
		stateTransitionOnTimeout[17]="Reload4";
		
		stateName[18]="Reload4";
		stateTimeoutValue[18]=0.46;
		stateSound[18]=ShotgunMagin;
		stateTransitionOnTimeout[18]="Reload5";
		
		stateName[19]="Reload5";
		stateTimeoutValue[19]=0.09;
		stateSound[19]=ShotgunPump1s;
		stateTransitionOnTimeout[19]="Reload6";
		
		stateName[20]="Reload6";
		stateTimeoutValue[20]=0.52;
		stateSound[20]=ShotgunPump2s;
		stateTransitionOnTimeout[20]="Wait";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.01;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	stateTimeoutValue[10]			= 0;
	stateTransitionOnTimeout[10]		= "Ready";
	stateTransitionOnTriggerDown[10]	= "Fire";
	
	stateName[11] 				= "ReloadSmoke";
	stateTimeoutValue[11]			= 0;
	stateTransitionOnTimeout[11]		= "Reload";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";

};

function ShotgunImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	%obj.spawnExplosion(SniperRecoilProjectile,"1 1 1");
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

	Parent::onFire(%this,%obj,%slot);
}

function ShotgunImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function ShotgunImage::onReloadStart(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function ShotgunImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}

function ShotgunImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function ShotgunImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}
