//audio
datablock AudioProfile(SniperShootSound)
{
   filename    = "./shoot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SniperBolt1s)
{
   filename    = "./bolt1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SniperBolt2s)
{
   filename    = "./bolt2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SniperMagout)
{
   filename    = "./magout.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SniperMagin1)
{
   filename    = "./magin.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SniperMagin2)
{
   filename    = "./magin2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(SniperRecoilExplosion)
{
   explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
  camShakeFreq = "1 1 1";
  camShakeAmp = "0 0.3 0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock ProjectileData(SniperRecoilProjectile)
{
	lifetime						= 10;
	fadeDelay						= 10;
	explodeondeath						= true;
	explosion						= SniperRecoilExplosion;

};
AddDamageType("Sniper",   '%1 shot himself.',    '%2 body-shot %1.',0.2,1);
AddDamageType("SniperHeadshot",   '%1 sniped himself.',    '%2 sniped %1.',0.2,1);
datablock ItemData(SniperItem : utaItem)
{
	shapeFile = "./item.dts";
	uiName = "Sniper";
	iconName = "./icon_ui";
	image = SniperImage;
	maxAmmo = 6;
};
datablock ShapeBaseImageData(SniperImage : utaImage)
{
   className = "WeaponImage";
   shapeFile = "./gun.dts";
   armReady = true;
   item = SniperItem;
   ammo = " ";
   projectile = utaProjectile;
   projectileType = Projectile;

   eyeOffset = "0.3 1.1 -0.3";

   casing = utaShellDebris;
	shellExitDir        = "-1.0 -1.3 1.0";
	shellExitOffset     = "0 0 -0.05";
	shellExitVariance   = 5.0;	
	shellVelocity       = 7.0;

   raycastWeaponRange = 800;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = utaProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 20;
   raycastDirectDamageType = $DamageType::Sniper;
   raycastCritDirectDamageType = $DamageType::SniperHeadshot;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0;
   raycastTracerProjectile = "";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 140;
   raycastVerticalImpulse = 100;
   
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.8;
	stateSequence[0] = "equip";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateEmitter[2]					= utaFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= SniperShootSound;

		//FIRE
		
		stateName[3]			= "Delay";
		stateTransitionOnTimeout[3]     = "Delay2";
		stateTimeoutValue[3]            = 0.42;
		
		stateName[14]			= "Delay2";
		stateTransitionOnTimeout[14]     = "Delay3";
		stateTimeoutValue[14]            = 0.15;
		stateSound[14] = SniperBolt1s;
		
		stateName[13]="Delay3";
		stateTransitionOnTimeout[13]     = "Delay4";
		stateTimeoutValue[13]            = 0.10;
		stateEjectShell[13]       	  = true;
		
		stateName[15]="Delay4";
		stateTransitionOnTimeout[15]     = "FireLoadCheckA";
		stateTimeoutValue[15]            = 0.53;
		stateSound[15] = SniperBolt2s;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";
	
		//RELOAD
	
		stateName[6]				= "Reload";
		stateTimeoutValue[6]			= 0.00;
		stateSequence[6]                = "Reload";
		stateScript[6]				= "onReloadStart";
		stateTransitionOnTimeout[6]		= "Reload2";
		stateWaitForTimeout[6]			= true;
		
		stateName[16]="Reload2";
		stateTimeoutValue[16]=0.4;
		stateTransitionOnTimeout[16]="Reload3";
		
		stateName[17]="Reload3";
		stateTimeoutValue[17]=0.6;
		stateSound[17]=SniperMagout;
		stateTransitionOnTimeout[17]="Reload4";
		
		stateName[18]="Reload4";
		stateTimeoutValue[18]=0.3;
		stateSound[18]=SniperMagin1;
		stateTransitionOnTimeout[18]="Reload5";
		
		stateName[19]="Reload5";
		stateTimeoutValue[19]=0.5;
		stateSound[19]=SniperMagin2;
		stateTransitionOnTimeout[19]="Reload6";
		
		stateName[20]="Reload6";
		stateTimeoutValue[20]=0.5;
		stateSound[20]=SniperBolt1s;
		stateTransitionOnTimeout[20]="Reload7";
		
		stateName[21]="Reload7";
		stateTimeoutValue[21]=0.7;
		stateSound[21]=SniperBolt2s;
		stateTransitionOnTimeout[21]="Wait";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.01;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	stateTimeoutValue[10]			= 0;
	stateTransitionOnTimeout[10]		= "Ready";
	stateTransitionOnTriggerDown[10]	= "Fire";
	
	stateName[11] 				= "ReloadSmoke";
	stateTimeoutValue[11]			= 0;
	stateTransitionOnTimeout[11]		= "Reload";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";

};

function SniperImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	%obj.spawnExplosion(SniperRecoilProjectile,"1 1 1");
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function SniperImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function SniperImage::onReloadStart(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function SniperImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}

function SniperImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function SniperImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}

function SniperImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
{
	parent::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
	if(%col.getType() & $TypeMasks::PlayerObjectType)
	{
		%colScale = getWord(%col.getScale(), 2);
		if(getWord(%pos, 2) > getWord(%col.getWorldBoxCenter(), 2) - 3.3 * %colScale && !%col.crouch)
		{
			%damage = %this.raycastDirectDamage * 3 - %this.raycastdirectdamage;
			%damageType = $DamageType::SniperHeadshot;
			if(%this.raycastdirectDamageType)
			{
				%damageType = %this.directDamageType;
			}
			%col.damage(%obj,%pos,%damage,%damageType);
		}
	}
	if(%col.crouch)
	{
		%damage = 0.5 * %this.raycastdirectDamage * 3 - %this.raycastdirectdamage;
		%damageType = $DamageType::SniperHeadshot;
		if(%this.raycastdirectDamageType)
		{
			%damageType = %this.directDamageType;
		}
		%col.damage(%obj,%pos,%damage,%damageType);
	}
}

function SniperProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = 20;
   %damage = %directDamage;

   %sobj = %obj.sourceObject;
   if(%sobj.getType() & $TypeMasks::PlayerObjectType)
   {
    // if(isObject(%sobj.client))
        // %sobj.client.play2d(bulletHitSound);
   }
   
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %colscale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      {
         %directDamage = %directDamage * 3;
         %damageType = $DamageType::Sniper; //$DamageType::SportRifleHeadshot;
         
         %col.spawnExplosion(critProjectile,%colscale);
         //if(isObject(%col.client))
            //%col.client.play2d(critRecieveSound);
         
         if(%sobj.getType() & $TypeMasks::PlayerObjectType)
         {
            serverplay3d(critFireSound,%sobj.getHackPosition());
            //if(isObject(%sobj.client))
               //%sobj.client.play2d(critHitSound);
         }
      }
      
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
}
